<template>
  <!-- <headers title="我的班级" /> -->
  <view class="class-container">
    <u-tabs
      :list="tabsState.list"
      :is-scroll="false"
      v-model="tabsState.current"
      bg-color="#f5f5f5"
      @change="tabsChange"
    />
    <!-- 搜索 -->
    <uni-search-bar
      placeholder="班级名称"
      bgColor="#ffffff"
      clearButton="auto"
      cancelButton="none"
      @confirm="search"
      @clear="clear"
    />
    <!-- 内容 -->
    <view v-if="classList.length">
      <text style="margin-bottom: 20rpx; display: block"
        >为你找到{{ listQuery.total }}个的班级</text
      >

      <block v-for="(item, index) in classList" :key="index">
        <classItem
          :classItem="item"
          :current="tabsState.current"
          @init="tabsChange"
        />
      </block>
      <view v-if="tabsState.current" style="padding: 20rpx">
        <u-loadmore :status="status" icon-type="flower" />
      </view>
    </view>
    <view v-else class="empty">
      <u-empty text="暂无数据" mode="list"></u-empty>
    </view>
  </view>
</template>

<script setup lang="ts">
// import headers from "@/components/header/index.vue"
import classItem from "./components/classItem.vue"
import { getClassList } from "@/api/class"
import { useGlobalStore } from "@/store/useStore"

const globalStore = useGlobalStore()

const tabsState = reactive({
  list: [
    {
      name: "进行中",
    },
    {
      name: "未开课",
    },
    {
      name: "已结课",
    },
  ],
  current: 0,
})

const classList = ref([] as any)

const listQuery = reactive({
  Phone: globalStore.Phone,
  type: 1,
  pageIndex: 1,
  pageSize: 10,
  total: 0,
  Name: "",
})

const status = ref("loadmore")

const tabsChange = (index: number) => {
  classList.value = []
  listQuery.pageIndex = 1
  listQuery.pageSize = 10
  switch (index) {
    case 0:
      listQuery.type = 1
      break
    case 1:
      listQuery.type = 0
      break
    default:
      listQuery.type = 2
      break
  }
  init()
}

const search = (val: any) => {
  listQuery.Name = val.value
  tabsChange(tabsState.current)
}

const clear = () => {
  listQuery.Name = ""
  tabsChange(tabsState.current)
}

// 上拉加载数据
onReachBottom(() => {
  // 判断是否还有下一页数据
  if (listQuery.pageIndex * listQuery.pageSize >= listQuery.total)
    return (status.value = "nomore")
  // // 判断是否正在请求其它数据，如果是，则不发起额外的请求
  if (status.value === "loading") return
  listQuery.pageIndex += 1
  init()
})

const init = async () => {
  status.value = "loading"
  const { data: res } = await getClassList(listQuery)
  if (res.code == 200) {
    if (res.total > 10) status.value = "loadmore"
    else status.value = "nomore"
    classList.value = [...classList.value, ...res.data]
    listQuery.total = res.total
  }
}

tabsChange(tabsState.current)
</script>

<style lang="scss" scoped>
.class-container {
  padding: 0 30rpx 30rpx;

  .uni-searchbar {
    padding: 0;
    margin: 20rpx 0;
  }
}
</style>
